@JS('AMap')
library amap;

import 'package:js/js.dart';
import 'dart:html' as html show window;

// 这里`new Map(id)` 调用js的`new AMap.Map(id)`
@JS('Map')
class AMap {
  external AMap(dynamic /*String|HTMLDivElement*/ div, MapOptions opts);

  /// 加载插件
  external plugin(dynamic /*String|List*/ name, void Function() callback);
}

@JS()
@anonymous
class MapOptions {
  external LngLat get center;

  external set center(LngLat v);

  external factory MapOptions({
    LngLat center,
    num zoom,
    String /*‘2D’|‘3D’*/ viewMode,
  });
}

@JS()
class LngLat {
  external num getLng();

  external num getLat();

  external LngLat(num lng, num lat);
}

/// 定位
@JS()
class Geolocation {
  external Geolocation(GeolocationOptions opts);

  external getCurrentPosition(
      void Function(String status, GeolocationResult result) callback);
}

@JS()
@anonymous
class GeolocationOptions {
  external factory GeolocationOptions({
    bool enableHighAccuracy, // 进行浏览器原生定位的时候是否尝试获取较高精度，可能影响定位效率，默认为false
    num timeout, // 定位的超时时间，毫秒
    bool convert, // 是否将定位结果转换为高德坐标
  });
}

@JS()
@anonymous
class GeolocationResult {
  external LngLat get position;

  external String get message;
}
